Spring Data Elasticsearch Changelog
===================================

Changes in version 4.2.1 (2021-05-14)
-------------------------------------
* #1811 - StringQuery execution crashes on return type `SearchPage<T>`.
* #1805 - Upgrade to Elasticsearch 7.12.1.
* #1794 - Refactor `DefaultReactiveElasticsearchClient` to do request customization with the `WebClient`.
* #1790 - Custom Query with string parameter which contains double quotes.
* #1787 - Search with MoreLikeThisQuery should use Pageable.
* #1785 - Fix documentation about auditing.
* #1778 - Custom property names must be used in SourceFilter and source fields.
* #1767 - DynamicMapping annotation should be applicable to any object field.


Changes in version 4.1.9 (2021-05-14)
-------------------------------------
* #1811 - StringQuery execution crashes on return type `SearchPage<T>`.
* #1790 - Custom Query with string parameter which contains double quotes.
* #1787 - Search with MoreLikeThisQuery should use Pageable.
* #1785 - Fix documentation about auditing.
* #1767 - DynamicMapping annotation should be applicable to any object field.


Changes in version 4.2.0 (2021-04-14)
-------------------------------------
* #1771 - Remove `@Persistent` from entity-scan include filters.
* #1761 - CriteriaQuery must use nested query only with properties of type nested.
* #1759 - health check with DefaultReactiveElasticsearchClient.
* #1758 - Nested Criteria queries must consider sub-fields.
* #1755 - Documentation fix to not show deprecated calls.
* #1754 - Types are in the process of being removed.
* #1753 - CriteriaQuery must support nested queries.
* #1390 - Introduce ClusterOperations [DATAES-818].


Changes in version 4.1.8 (2021-04-14)
-------------------------------------
* #1759 - health check with DefaultReactiveElasticsearchClient.


Changes in version 4.0.9.RELEASE (2021-04-14)
---------------------------------------------
* #1759 - health check with DefaultReactiveElasticsearchClient.


Changes in version 4.1.7 (2021-03-31)
-------------------------------------


Changes in version 4.2.0-RC1 (2021-03-31)
-----------------------------------------
* #1745 - Automatically close scroll context when returning streamed results.
* #1741 - Upgrade to Elasticsearch 7.12.
* #1738 - Readme lists artifacts with .RELEASE and .BUILD-SNAPSHOT suffixes.
* #1736 - Upgrade to OpenWebBeans 2.0.
* #1734 - Remove lombok.
* #1733 - Update CI to Java 16.
* #1727 - Allow multiple date formats for date fields.
* #1719 - Configure index settings with @Setting annotation.


Changes in version 4.2.0-M5 (2021-03-17)
----------------------------------------
* #1725 - Add support for SearchTemplate for reactive client.
* #1721 - IndexOps.getMapping raises exception if mapping contains "dynamic_templates".
* #1718 - Create index with mapping in one step.
* #1712 - Requests with ReactiveElasticsearchRepository methods doesn't fail if it can't connect with Elasticsearch.
* #1711 - Add the type hint _class attribute to the index mapping.
* #1704 - Add SearchFailure field in ByQueryResponse.
* #1700 - Add missing "Document ranking types".
* #1687 - Upgrade to Elasticsearch 7.11.
* #1686 - Add rescore functionality.
* #1678 - Errors are silent in multiGet.
* #1658 - ReactiveElasticsearchClient should use the same request parameters as non-reactive code.
* #1646 - Add function to list all indexes.
* #1514 - Add `matched_queries` field in SearchHit [DATAES-979].


Changes in version 4.1.6 (2021-03-17)
-------------------------------------
* #1712 - Requests with ReactiveElasticsearchRepository methods doesn't fail if it can't connect with Elasticsearch.


Changes in version 4.0.8.RELEASE (2021-03-17)
---------------------------------------------
* #1712 - Requests with ReactiveElasticsearchRepository methods doesn't fail if it can't connect with Elasticsearch.


Changes in version 4.2.0-M4 (2021-02-18)
----------------------------------------


Changes in version 4.1.5 (2021-02-18)
-------------------------------------


Changes in version 4.2.0-M3 (2021-02-17)
----------------------------------------
* #1689 - Missing anchor links in documentation.
* #1680 - After upgrade to 4.x can't read property id from _source named (different value from _id).
* #1679 - Errors are silent in delete by query in ReactiveElasticsearchTemplate.
* #1676 - Align MappingElasticsearchConverter with other Spring Data converters.
* #1675 - Consider Document as simple type.
* #1669 - Cleanup Deprecations from 4.0.
* #1668 - Writing a more complex CriteriaQuery.
* #1667 - Couldn't find PersistentEntity for type class com.example.demo.dto.Address.
* #1665 - ReactiveElasticsearchOperations indexName twice endcoding.
* #1662 - Documentation fix.
* #1659 - Fix source filter setup in multiget requests.
* #1655 - GeoJson types can be lowercase in Elasticsearch.
* #1649 - Upgrade to Elasticsearch 7.10.2.
* #1647 - Use own implementation of date formatters.
* #1644 - Implement update by query.
* #1565 - Allow using FieldNamingStrategy for property to fieldname matching [DATAES-993].
* #1370 - Add enabled mapping parameter to FieldType configuration [DATAES-798].
* #1218 - Add routing parameter to ElasticsearchOperations [DATAES-644].
* #1156 - Add @CountQuery annotation [DATAES-584].
* #1143 - Support for search_after [DATAES-571].
* #803 - Don't update indexed object if it is no persistent entity [DATAES-229].
* #725 - Add query Explain Support [DATAES-149].


Changes in version 4.1.4 (2021-02-17)
-------------------------------------
* #1667 - Couldn't find PersistentEntity for type class com.example.demo.dto.Address.
* #1665 - ReactiveElasticsearchOperations indexName twice endcoding.
* #1662 - Documentation fix.
* #1659 - Fix source filter setup in multiget requests.
* #1655 - GeoJson types can be lowercase in Elasticsearch.


Changes in version 4.0.7.RELEASE (2021-02-17)
---------------------------------------------
* DATAES-996 - Update CI jobs with Docker Login.
* #1667 - Couldn't find PersistentEntity for type class com.example.demo.dto.Address.
* #1665 - ReactiveElasticsearchOperations indexName twice endcoding.
* #1662 - Documentation fix.
* #1659 - Fix source filter setup in multiget requests.


Changes in version 3.2.13.RELEASE (2021-02-17)
----------------------------------------------
* #1694 - Upgrade to Elasticsearch 6.8.14.
* #1662 - Documentation fix.


Changes in version 4.2.0-M2 (2021-01-13)
----------------------------------------
* DATAES-1003 - add timeout to search query.
* DATAES-996 - Update CI jobs with Docker Login.
* DATAES-982 - Improve refresh handling.
* DATAES-946 - Support 'wildcard' field type.
* #1640 - Add support for GetFieldMapping request in ReactiveElasticsearchClient.
* #1638 - Upgrade to Elasticsearch 7.10.1.
* #1634 - Update Testcontainers dependency.
* #1632 - Update copyright notice to 2021.
* #1629 - Update repository after GitHub issues migration.
* #1576 - Add version of Spring dependency to docs [DATAES-1004].
* #1056 - Repository initialization should throw an Exception when index cannot be created [DATAES-481].


Changes in version 4.1.3 (2021-01-13)
-------------------------------------
* DATAES-996 - Update CI jobs with Docker Login.
* #1634 - Update Testcontainers dependency.


Changes in version 4.1.2 (2020-12-09)
-------------------------------------
* DATAES-991 - Wrong value for TermVector(with_positions_offets_payloads).
* DATAES-990 - Index creation fails with Authentication object cannot be null on startup.
* DATAES-987 - IndexOperations getMapping fail when using index alias.
* DATAES-978 - Accept DateFormat.none for a date property to enable custom Converters.
* DATAES-977 - Fix versions in reference documentation for 4.1.
* DATAES-973 - Release 4.1.2 (2020.0.2).
* DATAES-972 - BeforeConvertCallback should be called before index query is built.
* DATAES-543 - Adjust configuration support classes so they do not require proxying.


Changes in version 4.2.0-M1 (2020-12-09)
----------------------------------------
* DATAES-995 - Code Cleanup after DATACMNS-1838.
* DATAES-994 - Add setup for mutation testing.
* DATAES-991 - Wrong value for TermVector(with_positions_offets_payloads).
* DATAES-990 - Index creation fails with Authentication object cannot be null on startup.
* DATAES-989 - Improve deprecation warning for id properties without annotation.
* DATAES-988 - Allow specifying max results in NativeSearchQueryBuilder.
* DATAES-987 - IndexOperations getMapping fail when using index alias.
* DATAES-986 - Fix Javadoc.
* DATAES-985 - Add builder method for track_total_hits to NativeSearchQueryBuilder.
* DATAES-983 - Test dependency hoverfly-java-junit5 leaks into compile scope.
* DATAES-978 - Accept DateFormat.none for a date property to enable custom Converters.
* DATAES-976 - Implement CrudRepository.delete(Iterable<ID> ids).
* DATAES-975 - Upgrade to Elasticsearch 7.10.
* DATAES-974 - remove usage of deprecated WebClient exchange() method.
* DATAES-972 - BeforeConvertCallback should be called before index query is built.
* DATAES-971 - Fix tests for using a proxy with reactive client.
* DATAES-970 - Take Testcontainers version from the Spring Data Build pom.
* DATAES-969 - Use ResultProcessor in ElasticsearchPartQuery to build PartTree.
* DATAES-968 - Enable Maven caching for Jenkins jobs.
* DATAES-966 - Release 4.2 M1 (2021.0.0).
* DATAES-882 - HLRC Configuration - add ability to set max connections for the underlying HttpClient.
* DATAES-588 - Add support for custom callbacks in High Level/Low Level REST Client builder.
* DATAES-543 - Adjust configuration support classes so they do not require proxying.
* DATAES-362 - Add support for composable meta annotations.
* DATAES-247 - Support OpType in IndexQuery.


Changes in version 4.0.6.RELEASE (2020-12-09)
---------------------------------------------
* DATAES-991 - Wrong value for TermVector(with_positions_offets_payloads).
* DATAES-969 - Use ResultProcessor in ElasticsearchPartQuery to build PartTree.
* DATAES-968 - Enable Maven caching for Jenkins jobs.
* DATAES-964 - Release 4.0.6 (Neumann SR6).


Changes in version 3.2.12.RELEASE (2020-12-09)
----------------------------------------------
* DATAES-969 - Use ResultProcessor in ElasticsearchPartQuery to build PartTree.
* DATAES-963 - Release 3.2.12 (Moore SR12).


Changes in version 4.1.1 (2020-11-11)
-------------------------------------
* DATAES-969 - Use ResultProcessor in ElasticsearchPartQuery to build PartTree.
* DATAES-968 - Enable Maven caching for Jenkins jobs.
* DATAES-965 - Release 4.1.1 (2020.0.1).


Changes in version 4.1.0 (2020-10-28)
-------------------------------------
* DATAES-962 - Deprecate Joda support.
* DATAES-960 - Upgrade to Elasticsearch 7.9.3.
* DATAES-956 - Prevent double converter registration.
* DATAES-953 - DateTimeException occurred "yyyy-MM-dd HH: mm: ss" string is converted to Date.
* DATAES-952 - Optimize SearchPage implementation.
* DATAES-951 - Revert DATAES-934.
* DATAES-950 - Release 4.1 GA (2020.0.0).
* DATAES-931 - Add query support for geo shape queries.
* DATAES-796 - Provide new method to return SearchHits in ReactiveElasticsearchClient.


Changes in version 4.0.5.RELEASE (2020-10-28)
---------------------------------------------
* DATAES-953 - DateTimeException occurred "yyyy-MM-dd HH: mm: ss" string is converted to Date.
* DATAES-937 - Repository queries with IN filters fail with empty input list.
* DATAES-936 - Take id property from the source when deserializing an entity.
* DATAES-926 - Release 4.0.5 (Neumann SR5).


Changes in version 3.2.11.RELEASE (2020-10-28)
----------------------------------------------
* DATAES-961 - Upgrade to Elasticsearch 6.8.13.
* DATAES-937 - Repository queries with IN filters fail with empty input list.
* DATAES-925 - Release 3.2.11 (Moore SR11).


Changes in version 3.1.21.RELEASE (2020-10-28)
----------------------------------------------
* DATAES-958 - Release 3.1.21 (Lovelace SR21).


Changes in version 4.1.0-RC2 (2020-10-14)
-----------------------------------------
* DATAES-949 - dependency cleanup.
* DATAES-947 - Adopt to API changes in Project Reactor.
* DATAES-945 - Compilation error on JDK11+.
* DATAES-944 - Simplify logging setup in test environment.
* DATAES-943 - Add missing mapping parameters.
* DATAES-940 - Update to Elasticsearch 7.9.2.
* DATAES-937 - Repository queries with IN filters fail with empty input list.
* DATAES-936 - Take id property from the source when deserializing an entity.
* DATAES-935 - Setup integration tests separate from unit tests.
* DATAES-934 - Add a Query taking method to ElasticsearchRepository.
* DATAES-933 - Fix typo in javaDoc.
* DATAES-932 - GeoPoint - Point conversion is wrong.
* DATAES-930 - Add support for geo_shape type entity properties.
* DATAES-929 - Support geo_shape field type field type.
* DATAES-927 - Release 4.1 RC2 (2020.0.0).
* DATAES-921 - Investigate WebClient.retrieve() instead of using WebClient.exchange().


Changes in version 4.1.0-RC1 (2020-09-16)
-----------------------------------------
* DATAES-924 - Conversion of properties of collections of Temporal values fails.
* DATAES-923 - Upgrade to Elasticsearch 7.9.1.
* DATAES-922 - Move off Sink.emitXXX methods.
* DATAES-920 - Add parameter to @Field annotation to store null values.
* DATAES-919 - Fix error messages in test output.
* DATAES-914 - Use Testcontainers.
* DATAES-913 - Minor optimization on collection-returning derived queries.
* DATAES-912 - Derived Query with "In" Keyword does not work on Text field.
* DATAES-911 - Add documentation for automatic index creation.
* DATAES-910 - Upgrade to Elasticsearch 7.9.0.
* DATAES-909 - Add singular update() methods to ReactiveDocumentOperations.
* DATAES-908 - Fill version on an indexed entity.
* DATAES-907 - Track Total Hits not working when set to false.
* DATAES-904 - Release 4.1 RC1 (2020.0.0).
* DATAES-902 - Update to Elasticsearch 7.8.1.
* DATAES-898 - Add join-type relevant parts to reactive calls.
* DATAES-895 - Criteria.OperationKey.NEAR is not used anywhere.
* DATAES-854 - Add support for rank_feature datatype.
* DATAES-706 - CriteriaQueryProcessor must handle nested Criteria definitions.


Changes in version 4.0.4.RELEASE (2020-09-16)
---------------------------------------------
* DATAES-924 - Conversion of properties of collections of Temporal values fails.
* DATAES-912 - Derived Query with "In" Keyword does not work on Text field.
* DATAES-905 - Release 4.0.4 (Neumann SR4).


Changes in version 3.2.10.RELEASE (2020-09-16)
----------------------------------------------
* DATAES-903 - Update to Elasticsearch 6.8.12.
* DATAES-892 - Fix ElasticsearchEntityMapper recursive descent when reading Map objects.
* DATAES-888 - Release 3.2.10 (Moore SR10).


Changes in version 3.1.20.RELEASE (2020-09-16)
----------------------------------------------
* DATAES-887 - Release 3.1.20 (Lovelace SR20).


Changes in version 4.0.3.RELEASE (2020-08-12)
---------------------------------------------
* DATAES-897 - Add documentation for Highlight annotation.
* DATAES-896 - Use mainField property of @MultiField annotation instead of additional @Field annotation.
* DATAES-891 - Returning a Stream from a Query annotated repository method crashes.
* DATAES-890 - Release 4.0.3 (Neumann SR3).


Changes in version 4.1.0-M2 (2020-08-12)
----------------------------------------
* DATAES-901 - Operations deleting an entity should use a routing deducted from the entity.
* DATAES-899 - Add documentation for join-type.
* DATAES-897 - Add documentation for Highlight annotation.
* DATAES-896 - Use mainField property of @MultiField annotation instead of additional @Field annotation.
* DATAES-894 - Adapt to changes in Reactor.
* DATAES-893 - Adopt to changed module layout of Reactor Netty.
* DATAES-891 - Returning a Stream from a Query annotated repository method crashes.
* DATAES-886 - Complete reactive auditing.
* DATAES-883 - Fix log level on resource load error.
* DATAES-878 - Wrong value for TermVector(woth_positions_offsets).
* DATAES-877 - Update test logging dependency.
* DATAES-876 - Add seqno and primary term to entity on initial save.
* DATAES-875 - MappingElasticsearchConverter.updateQuery not called at all places.
* DATAES-874 - Deprecate parent-id related methods and fields.
* DATAES-872 - Release 4.1 M2 (2020.0.0).
* DATAES-869 - Update to Elasticsearch 7.8.
* DATAES-864 - Rework alias management.
* DATAES-842 - Documentation fixes.
* DATAES-612 - Add support for index templates.
* DATAES-433 - Replace parent-child mappings to join field.
* DATAES-321 - Support time base rolling indices.
* DATAES-244 - Support alias renaming.
* DATAES-233 - Support for rolling index strategy.
* DATAES-207 - Allow fetching indices by alias.
* DATAES-192 - Define alias for document.
* DATAES-150 - mapping are not created when entity is saved in new dynamic name index (spel).


Changes in version 4.0.2.RELEASE (2020-07-22)
---------------------------------------------
* DATAES-883 - Fix log level on resource load error.
* DATAES-878 - Wrong value for TermVector(woth_positions_offsets).
* DATAES-865 - Fix MappingElasticsearchConverter writing an Object property containing a Map.
* DATAES-863 - Improve server error response handling.
* DATAES-862 - Release 4.0.2 (Neumann SR2).


Changes in version 3.2.9.RELEASE (2020-07-22)
---------------------------------------------
* DATAES-861 - Release 3.2.9 (Moore SR9).


Changes in version 3.1.19.RELEASE (2020-07-22)
----------------------------------------------
* DATAES-860 - Release 3.1.19 (Lovelace SR19).


Changes in version 4.1.0-M1 (2020-06-25)
----------------------------------------
* DATAES-870 - Workaround for reactor-netty error.
* DATAES-868 - Upgrade to Netty 4.1.50.Final.
* DATAES-867 - Adopt to changes in Reactor Netty 1.0.
* DATAES-866 - Implement suggest search in reactive client.
* DATAES-865 - Fix MappingElasticsearchConverter writing an Object property containing a Map.
* DATAES-863 - Improve server error response handling.
* DATAES-859 - Don't use randomNumeric() in tests.
* DATAES-858 - Use standard Spring code of conduct.
* DATAES-857 - Registered simple types are not read from list.
* DATAES-853 - Cleanup tests that do not delete test indices.
* DATAES-852 - Upgrade to Elasticsearch 7.7.1.
* DATAES-850 - Add warning and documentation for missing TemporalAccessor configuration.
* DATAES-848 - Add the name of the index to SearchHit.
* DATAES-847 - Add missing DateFormat values.
* DATAES-845 - MappingElasticsearchConverter crashes when writing lists containing null values.
* DATAES-844 - Improve TOC formatting for migration guides.
* DATAES-841 - Remove deprecated type mappings code.
* DATAES-840 - Consolidate index name SpEL resolution.
* DATAES-839 - ReactiveElasticsearchTemplate should use RequestFactory.
* DATAES-838 - Update to Elasticsearch 7.7.0.
* DATAES-836 - Fix typo in Javadocs.
* DATAES-835 - Fix code sample in documentation for scroll API.
* DATAES-832 - findAllById repository method returns iterable with null elements for not found ids.
* DATAES-831 - SearchOperations.searchForStream does not use requested maxResults.
* DATAES-829 - Deprecate AbstractElasticsearchRepository and cleanup SimpleElasticsearchRepository.
* DATAES-828 - Fields of type date need to have a format defined.
* DATAES-827 - Repositories should not try to create an index when it already exists.
* DATAES-826 - Add method to IndexOperations to write an index mapping from a entity class.
* DATAES-825 - Update readme to use latest spring.io docs.
* DATAES-824 - Release 4.1 M1 (2020.0.0).
* DATAES-678 - Introduce ReactiveIndexOperations.
* DATAES-263 - Inner Hits support.


Changes in version 4.0.1.RELEASE (2020-06-10)
---------------------------------------------
* DATAES-857 - Registered simple types are not read from list.
* DATAES-850 - Add warning and documentation for missing TemporalAccessor configuration.
* DATAES-845 - MappingElasticsearchConverter crashes when writing lists containing null values.
* DATAES-844 - Improve TOC formatting for migration guides.
* DATAES-839 - ReactiveElasticsearchTemplate should use RequestFactory.
* DATAES-835 - Fix code sample in documentation for scroll API.
* DATAES-832 - findAllById repository method returns iterable with null elements for not found ids.
* DATAES-831 - SearchOperations.searchForStream does not use requested maxResults.
* DATAES-828 - Fields of type date need to have a format defined.
* DATAES-827 - Repositories should not try to create an index when it already exists.
* DATAES-823 - Release 4.0.1 (Neumann SR1).


Changes in version 3.2.8.RELEASE (2020-06-10)
---------------------------------------------
* DATAES-851 - Upgrade to Elasticsearch 6.8.10.
* DATAES-837 - Update to Elasticsearch 6.8.9.
* DATAES-821 - Fix code for adding an alias.
* DATAES-811 - Remove Travis CI.
* DATAES-807 - Release 3.2.8 (Moore SR8).
* DATAES-776 - Adapt RestClients class to change in InetSocketAddress class in JDK14.
* DATAES-767 - Fix ReactiveElasticsearch handling of 4xx HTTP responses.


Changes in version 3.1.18.RELEASE (2020-06-10)
----------------------------------------------
* DATAES-811 - Remove Travis CI.
* DATAES-806 - Release 3.1.18 (Lovelace SR18).


Changes in version 4.0.0.RELEASE (2020-05-12)
---------------------------------------------
* DATAES-822 - ElasticsearchRestTemplate should not use `spring-web`.
* DATAES-821 - Fix code for adding an alias.
* DATAES-819 - Test refactorings.
* DATAES-817 - StreamQueries does only delete the last scrollid.
* DATAES-814 - Fix documentation.
* DATAES-812 - IndexOperations should use SpEL index name from entity.
* DATAES-811 - Remove Travis CI.
* DATAES-809 - Creation of test data may lead to duplicate values.
* DATAES-808 - Release 4.0 GA (Neumann).
* DATAES-799 - Support optimistic locking for full update scenario using seq_no + primary_term.
* DATAES-767 - Fix ReactiveElasticsearch handling of 4xx HTTP responses.
* DATAES-750 - Migration guide and documentation update.
* DATAES-602 - add support for refreshAsync into ElasticsearchRestTemplate.
* DATAES-587 - Add lifecycle events.
* DATAES-267 - ElasticSearch should allow to create nested not analyzed fields.


Changes in version 4.0.0.RC2 (2020-04-28)
-----------------------------------------
* DATAES-803 - Move count request setup from reactive template to reactive client.
* DATAES-802 - Update documentation for using scroll API with repository methods.
* DATAES-801 - Implement callback to enable adding custom headers in the REST HTTP request.
* DATAES-800 - De-Lombok production code.
* DATAES-797 - Fix MappingElasticsearchConverter recursive descent when reading Map objetcsa.
* DATAES-795 - Fix MappingElasticsearchConverter conversion from Document into Map<String, Object>.
* DATAES-794 - MappingBuilder must not write empty mapping properties.
* DATAES-792 - Add java.util.Date to the supported types for Field annonation date times.
* DATAES-791 - DocumentOperations.multiGet() implementations must return null values for  not found entities.
* DATAES-790 - Deprecate noRefresh repository method.
* DATAES-789 - Make ElasticsearchRestTemplate.ClientCallback public.
* DATAES-788 - Add missing path mapping to completion context.
* DATAES-787 - Use JDK 14 for Java.NEXT CI testing.
* DATAES-786 - Move the creation of SearchHit(s) from ElasticsearchConverter closer to ElasticsearchTemplate.
* DATAES-785 - Various entity callbacks implementation improvements.
* DATAES-784 - MappingBuilder should use @Field annotation with custom value objects.
* DATAES-782 - Make underlying TransportClient accessible.
* DATAES-781 - Upgrade to Elasticsearch 7.6.2.
* DATAES-778 - Fix SSL setup in the reactive client.
* DATAES-777 - SearchHitsSupport must preserve pageable when unwrapping to AggregatedPage.
* DATAES-776 - Adapt RestClients class to change in InetSocketAddress class in JDK14.
* DATAES-775 - Fix test runner setup.
* DATAES-774 - Release 4.0 RC2 (Neumann).
* DATAES-773 - Add search-as-you-type field support to index mappings.
* DATAES-772 - Add after-convert entity callbacks support.
* DATAES-567 - Unable to read aggregations via Reactive*Operations.


Changes in version 3.2.7.RELEASE (2020-04-28)
---------------------------------------------
* DATAES-780 - Upgrade 3.2.x to Elasticsearch 6.8.8.
* DATAES-778 - Fix SSL setup in the reactive client.
* DATAES-770 - Release 3.2.7 (Moore SR7).


Changes in version 3.1.17.RELEASE (2020-04-28)
----------------------------------------------
* DATAES-793 - Upgrade to Elasticsearch 6.2.4.
* DATAES-755 - Release 3.1.17 (Lovelace SR17).


Changes in version 4.0.0.RC1 (2020-03-31)
-----------------------------------------
* DATAES-771 - Add after-save entity callbacks support.
* DATAES-768 - Add missing query parameters for an UpdateQuery.
* DATAES-766 - Replace CloseableIterator with SearchHitsIterator in stream operations.
* DATAES-765 - Pageable.unpaged() is not used to build a query returning all documents.
* DATAES-763 - Allow map properties in entity with null values.
* DATAES-762 - Release 4.0 RC1 (Neumann).
* DATAES-751 - Introduce ClientCallbackfor the rest client.
* DATAES-653 - Make it easier to use a custom request converter when extending DefaultReactiveElasticsearchClient.
* DATAES-435 - Report version mismatch if used with older ElasticSearch version.
* DATAES-382 - Add Exception translation for Elasticsearch errors.
* DATAES-68 - Add support for auditing annotations.


Changes in version 3.2.6.RELEASE (2020-03-25)
---------------------------------------------
* DATAES-769 - Upgrade to Elasticsearch 6.8.7.
* DATAES-765 - Pageable.unpaged() is not used to build a query returning all documents.
* DATAES-764 - StreamQueries#streamResults does not clear scroll context when finished.
* DATAES-763 - Allow map properties in entity with null values.
* DATAES-758 - fix documentation for @Query annotation.
* DATAES-756 - Release 3.2.6 (Moore SR6).


Changes in version 4.0.0.M4 (2020-03-11)
----------------------------------------
* DATAES-759 - Update to Elasticsearch 7.6.1.
* DATAES-758 - fix documentation for @Query annotation.
* DATAES-754 - Completion field deserialization is failing due to class cast error.
* DATAES-753 - Reactive Elasticsearch repository: Bulk update fails on empty entity list.
* DATAES-749 - Introduce SearchPage as return type for repository methods.
* DATAES-747 - ElasticsearchConfigurationSupport does not set customConversions into the MappingElasticsearchConverter.
* DATAES-746 - Add store converters to convert binary data to base64 encoded strings.
* DATAES-745 - Consolidate Operations API.
* DATAES-744 - Release 4.0 M4 (Neumann).
* DATAES-741 - Tests fail due to Elasticsearch cluster 'blocks' on nearly-full file-systems.
* DATAES-282 - Remove all low-level reflection based field inspection from MappingBuilder in favor of PersistentProperty inspections.


Changes in version 3.2.5.RELEASE (2020-02-26)
---------------------------------------------
* DATAES-752 - Upgrade to Elasticsearch 6.8.6.
* DATAES-741 - Tests fail due to Elasticsearch cluster 'blocks' on nearly-full file-systems.
* DATAES-730 - Release 3.2.5 (Moore SR5).
* DATAES-214 - ElasticsearchTemplate's prepareSearch(Query query) method should use getOffset().


Changes in version 3.1.16.RELEASE (2020-02-26)
----------------------------------------------
* DATAES-729 - Release 3.1.16 (Lovelace SR16).


Changes in version 4.0.0.M3 (2020-02-12)
----------------------------------------
* DATAES-743 - Revert geo converters to back to store converters.
* DATAES-740 - Adapt to spring-data-commons changes.
* DATAES-739 - Introduce nullable annotations for API validation.
* DATAES-738 - Add entity related save methods to DocumentOperations.
* DATAES-735 - Update to Elasticsearch 7.5.2.
* DATAES-734 - Add Sort implementation that allows geo distance sorts.
* DATAES-732 - Release 4.0 M3 (Neumann).
* DATAES-449 - Pass route parameter to created search request.


Changes in version 4.0.0.M2 (2020-01-17)
----------------------------------------
* DATAES-731 - Release 4.0 M2 (Neumann).


Changes in version 4.0.0.M1 (2020-01-16)
----------------------------------------
* DATAES-727 - Use track_total_hits parameter for count queries.
* DATAES-725 - Update copyright years to 2020.
* DATAES-724 - Provide IndexOperations bean.
* DATAES-723 - Cleanup ElasticsearchRepository interface.
* DATAES-722 - Return total count relation in the SearchHits object.
* DATAES-721 - Deprecation and Warnings cleanup.
* DATAES-720 - SimpleReactiveElasticsearchRepository findAll() returns only 10 elements.
* DATAES-719 - Add customization hook for reactive WebClient.
* DATAES-718 - Deprecate @Score and scoreProperty.
* DATAES-717 - Enable Repositories to return a SearchHits instance instead of a list.
* DATAES-716 - Add Value mapping to the ElasticsearchMappingConverter.
* DATAES-715 - Highlight results should be returned in the SearchHits.
* DATAES-714 - Sort results should be returned in the SearchHits.
* DATAES-713 - Transfer returned aggregations from the AggregatedPage to the SearchHits.
* DATAES-711 - Update to Elasticsearch 7.5.
* DATAES-709 - Add parameter to include default settings on setting request.
* DATAES-702 - Travis CI builds currently broken.
* DATAES-701 - Enable proxy support for the reactive rest template.
* DATAES-700 - Enable proxy support for RestClient.
* DATAES-697 - Query refactoring cleanup.
* DATAES-693 - Support for source fetching in update operations.
* DATAES-690 - Enable builds on JDK 11+.
* DATAES-688 - Remove unneeded SearchQuery subinterface.
* DATAES-684 - Implement Bulk Request for Reactive.
* DATAES-680 - ReactiveElasticsearchTemplate should use the count API.
* DATAES-677 - Update to Elasticsearch 7.4.1.
* DATAES-676 - fix documentation to reflect the changes in API restructuring.
* DATAES-675 - migrate tests to JUnit 5.
* DATAES-673 - Create a Ssl Rest Client using SslContext and HostnameVerifier.
* DATAES-672 - Introduce SearchHit to enrich an Entity type.
* DATAES-671 - Missing indicesOptions support for scrolling queries.
* DATAES-670 - fix version compatibility matrix in documentation.
* DATAES-666 - Rebase branch 4.0.x onto master and merge it.
* DATAES-665 - Javadoc not deployed.
* DATAES-663 - Release 4.0 M1 (Neumann).
* DATAES-661 - Support track_total_hits request parameter.
* DATAES-659 - Move MappingElasticsearchConverter to correct package.
* DATAES-658 - Update 4.0.x to ES 7.3.2.
* DATAES-654 - Add Junit 5 support.
* DATAES-651 - Fix regression from escaping.
* DATAES-650 - Add support for pathPrefix to ClientConfiguration.
* DATAES-647 - In and NotIn uses should instead of terms-query.
* DATAES-639 - Add ignore_above mapping parameter support.
* DATAES-638 - Remove redundant public modifiers in @MultiField.
* DATAES-637 - Change branch 4.0. to use Elasticsearch 7.3.
* DATAES-635 - Create branch 4.0.x and integrate the changes from the existing 4.x branch.
* DATAES-634 - Rearrange methods in Template API.
* DATAES-633 - Introduce value object to capture index type/index name.
* DATAES-632 - Use single Query type in Template API methods.
* DATAES-631 - Consolidate query objects.


Changes in version 3.2.4.RELEASE (2020-01-15)
---------------------------------------------
* DATAES-725 - Update copyright years to 2020.
* DATAES-720 - SimpleReactiveElasticsearchRepository findAll() returns only 10 elements.
* DATAES-719 - Add customization hook for reactive WebClient.
* DATAES-705 - Add support for PathPrefix  to clients in 3.2.x.
* DATAES-704 - Release 3.2.4 (Moore SR4).


Changes in version 3.1.15.RELEASE (2020-01-15)
----------------------------------------------
* DATAES-725 - Update copyright years to 2020.
* DATAES-703 - Release 3.1.15 (Lovelace SR15).


Changes in version 3.2.3.RELEASE (2019-12-04)
---------------------------------------------
* DATAES-700 - Enable proxy support for RestClient.
* DATAES-699 - ElasticsearchRestTemplate.count(..) returns all documents instead of just total hits number.
* DATAES-692 - Release 3.2.3 (Moore SR3).


Changes in version 3.1.14.RELEASE (2019-12-04)
----------------------------------------------
* DATAES-691 - Release 3.1.14 (Lovelace SR14).


Changes in version 3.2.2.RELEASE (2019-11-18)
---------------------------------------------
* DATAES-685 - Release 3.2.2 (Moore SR2).
* DATAES-684 - Implement Bulk Request for Reactive.
* DATAES-680 - ReactiveElasticsearchTemplate should use the count API.


Changes in version 3.1.13.RELEASE (2019-11-18)
----------------------------------------------
* DATAES-683 - Release 3.1.13 (Lovelace SR13).


Changes in version 3.2.1.RELEASE (2019-11-04)
---------------------------------------------
* DATAES-679 - Upgrade to Elasticsearch 6.8.4.
* DATAES-673 - Create a Ssl Rest Client using SslContext and HostnameVerifier.
* DATAES-671 - Missing indicesOptions support for scrolling queries.
* DATAES-670 - fix version compatibility matrix in documentation.
* DATAES-665 - Javadoc not deployed.
* DATAES-662 - Release 3.2.1 (Moore SR1).


Changes in version 3.1.12.RELEASE (2019-11-04)
----------------------------------------------
* DATAES-660 - Release 3.1.12 (Lovelace SR12).


Changes in version 3.2.0.RELEASE (2019-09-30)
---------------------------------------------
* DATAES-657 - Sort by _score not supported by ElasticsearchRestTemplate.
* DATAES-652 - Send if_seq_no and if_primary_term parameters when indexing via ReactiveElasticsearchClient.
* DATAES-648 - Unify documentation of version compatibilities.
* DATAES-625 - Release 3.2 GA (Moore).
* DATAES-541 - IllegalArgumentException on ElasticsearchRestTemplate#removeAlias.
* DATAES-305 - let users create mappings with dynamical indexName.
* DATAES-227 - ElasticsearchTemplate.prepareUpdate should call setUpsert.


Changes in version 3.1.11.RELEASE (2019-09-30)
----------------------------------------------
* DATAES-627 - Add HTTPS entries into spring.schemas.
* DATAES-624 - Release 3.1.11 (Lovelace SR11).


Changes in version 3.2.0.RC3 (2019-09-06)
-----------------------------------------
* DATAES-646 - Adapt to Spring Framework 5.2 RC2.
* DATAES-645 - Missing highlight support for scrolling queries.
* DATAES-643 - RestTemplate ignores search_type.
* DATAES-627 - Add HTTPS entries into spring.schemas.
* DATAES-626 - Release 3.2 RC3 (Moore).


Changes in version 3.2.0.RC2 (2019-08-05)
-----------------------------------------
* DATAES-619 - Migrate remaining tests to AssertJ.
* DATAES-616 - Fix implementations of ParameterAccessor interface.
* DATAES-615 - OrderBy clause on repository queries does not honour @Field name annotation.
* DATAES-611 - Adapt to API changes in Spring Webflux.
* DATAES-610 - Clarify inclusion of rc and snapshot builds in readme.adoc.
* DATAES-609 - Fix TransportClientFactoryBean.isSingleton().
* DATAES-607 - Add client security configuration options for Rest clients.
* DATAES-606 - update 3.2.x to use ES 6.8.1.
* DATAES-604 - Revise readme for a consistent structure.
* DATAES-603 - Add support for bulk options in Elasticsearch-Template classes.
* DATAES-601 - Fix NoHTTP errors.
* DATAES-598 - Add Elasticsearch authentication code example to readme.
* DATAES-597 - Fix code formatting in readme.
* DATAES-595 - Support for setting preference parameter in query.
* DATAES-594 - Support for Index without refresh.
* DATAES-593 - Add support for field collapse function.
* DATAES-592 - Integrate nohttp tooling into CI build profile.
* DATAES-591 - Release 3.2 RC2 (Moore).
* DATAES-583 - Introduce Jenkins CI.
* DATAES-497 - Revise reference documentation.
* DATAES-456 - AbstractElasticsearchRepository.save(S entity) does not evaluate @Document(indexName) expression.
* DATAES-415 - More Field Types Support.
* DATAES-405 - use @Nullable from org.springframework.lang.
* DATAES-387 - Index Not Found Exception When Using Spring EL in Index Name/Type.


Changes in version 3.1.10.RELEASE (2019-08-05)
----------------------------------------------
* DATAES-592 - Integrate nohttp tooling into CI build profile.
* DATAES-590 - Release 3.1.10 (Lovelace SR10).
* DATAES-583 - Introduce Jenkins CI.


Changes in version 2.1.23.RELEASE (2019-08-05)
----------------------------------------------
* DATAES-583 - Introduce Jenkins CI.
* DATAES-581 - Release 2.1.23 (Ingalls SR23).


Changes in version 3.2.0.RC1 (2019-06-14)
-----------------------------------------
* DATAES-589 - improve readme file.
* DATAES-586 - Create security policy readme.
* DATAES-579 - Test Code Cleanup.
* DATAES-560 - Release 3.2 RC1 (Moore).


Changes in version 3.1.9.RELEASE (2019-06-14)
---------------------------------------------
* DATAES-580 - Release 3.1.9 (Lovelace SR9).


Changes in version 2.1.22.RELEASE (2019-05-13)
----------------------------------------------
* DATAES-578 - Release 2.1.22 (Ingalls SR22).


Changes in version 3.1.8.RELEASE (2019-05-13)
---------------------------------------------
* DATAES-577 - Release 3.1.8 (Lovelace SR8).


Changes in version 3.2.0.M4 (2019-05-13)
----------------------------------------
* DATAES-576 - ElasticsearchTransportTemplateTests.shouldDeleteAcrossIndex(…) consistently fails.
* DATAES-575 - Upgrade to Elasticsearch 6.7.2.
* DATAES-572 - Indices created in ElasticsearchTemplateTests are retained after tests.
* DATAES-570 - Use Delete By Query API for delete by query operations.
* DATAES-569 - Add index operations to reactive Elasticsearch client.
* DATAES-568 - MappingBuilder must use the @Field annotation's name attribute.
* DATAES-566 - Double  SearchHit source to string conversion in DefaultResultMapper.
* DATAES-565 - ElasticsearchTemplate.prepareScroll() doesn't respect SourceFilter from the Query.
* DATAES-564 - Release 3.2 M4 (Moore).
* DATAES-563 - Add "elasticsearchTemplate" bean alias for ElasticsearchTemplate.
* DATAES-562 - Custom name attribute for @Field mapping in ElasticsearchEntityMapper.
* DATAES-561 - Reuse ObjectMapper in ElasticsearchEntityMapper.
* DATAES-546 - Documentation code snippet for "using @Query Annotation" does not compile.
* DATAES-459 - ElasticsearchTemplate does not provide the scroll ID with startScroll.
* DATAES-457 - ElasticsearchTemplate.prepareScroll() does not add sorting.


Changes in version 2.1.21.RELEASE (2019-05-10)
----------------------------------------------
* DATAES-555 - Release 2.1.21 (Ingalls SR21).


Changes in version 3.1.7.RELEASE (2019-05-10)
---------------------------------------------
* DATAES-557 - Release 3.1.7 (Lovelace SR7).
* DATAES-552 - @Query annotation fail when passing in over 10 parameters.
* DATAES-547 - ElasticSearchTemplate.delete(DeleteQuery, Class) does not delete documents.


Changes in version 3.2.0.M3 (2019-04-11)
----------------------------------------
* DATAES-558 - Upgrade Elastic Search version to 6.6.2.
* DATAES-552 - @Query annotation fail when passing in over 10 parameters.
* DATAES-547 - ElasticSearchTemplate.delete(DeleteQuery, Class) does not delete documents.
* DATAES-545 - Move off deprecations in Spring Data Commons.
* DATAES-542 - Release 3.2 M3 (Moore).
* DATAES-536 - Add support for context suggestion.
* DATAES-535 - Add mapping annotation @DynamicTemplates.
* DATAES-530 - Add alternative to Jackson ObjectMapper for result mapping.


Changes in version 3.1.6.RELEASE (2019-04-01)
---------------------------------------------
* DATAES-538 - Release 3.1.6 (Lovelace SR6).
* DATAES-536 - Add support for context suggestion.
* DATAES-535 - Add mapping annotation @DynamicTemplates.
* DATAES-523 - Allow specifying version type for index API.


Changes in version 3.0.14.RELEASE (2019-04-01)
----------------------------------------------
* DATAES-528 - Release 3.0.14 (Kay SR14).
* DATAES-523 - Allow specifying version type for index API.
* DATAES-500 - queryForList(CriteriaQuery query, Class<T> clazz) can't query all data.


Changes in version 2.1.20.RELEASE (2019-04-01)
----------------------------------------------
* DATAES-554 - Release 2.1.20 (Ingalls SR20).


Changes in version 2.1.19.RELEASE (2019-04-01)
----------------------------------------------
* DATAES-527 - Release 2.1.19 (Ingalls SR19).


Changes in version 3.2.0.M2 (2019-03-07)
----------------------------------------
* DATAES-537 - Upgrade to Elasticsearch 6.6.
* DATAES-531 - ElasticsearchRestTemplate.getMapping always returns null.
* DATAES-526 - Introduce Concourse CI.
* DATAES-525 - ElasticsearchRestRemplate bulk delete by ID removes all objects from index.
* DATAES-524 - Update copyright years to 2019.
* DATAES-523 - Allow specifying version type for index API.
* DATAES-521 - Remove specific repository implementations for UUID und Numbers as id type.
* DATAES-519 - Add support for reactive repositories.
* DATAES-518 - Use scroll for unpaged find operations in ReactiveElasticsearchTemplate.
* DATAES-517 - Release 3.2 M2 (Moore).
* DATAES-510 - Add support for reactive scrolling.
* DATAES-500 - queryForList(CriteriaQuery query, Class<T> clazz) can't query all data.


Changes in version 3.1.5.RELEASE (2019-02-13)
---------------------------------------------
* DATAES-529 - Release 3.1.5 (Lovelace SR5).
* DATAES-500 - queryForList(CriteriaQuery query, Class<T> clazz) can't query all data.


Changes in version 3.1.4.RELEASE (2019-01-10)
---------------------------------------------
* DATAES-524 - Update copyright years to 2019.
* DATAES-507 - Release 3.1.4 (Lovelace SR4).


Changes in version 3.0.13.RELEASE (2019-01-10)
----------------------------------------------
* DATAES-524 - Update copyright years to 2019.
* DATAES-506 - Release 3.0.13 (Kay SR13).


Changes in version 2.1.18.RELEASE (2019-01-10)
----------------------------------------------
* DATAES-524 - Update copyright years to 2019.
* DATAES-505 - Release 2.1.18 (Ingalls SR18).


Changes in version 3.2.0.M1 (2018-12-11)
----------------------------------------
* DATAES-515 - Override Elasticsearch's JarHell for tests.
* DATAES-514 - Simplify reference documentation setup.
* DATAES-513 - Release 3.2 M1 (Moore).
* DATAES-508 - Set up Travis-ci build.
* DATAES-503 - Missing copy_to property in @Field Annotation.
* DATAES-492 - Missing normalizer property in @Field and @InnerField Annotation.
* DATAES-445 - Usage example of scan and scroll is misleading.
* DATAES-407 - Add support for Java High Level REST Client.


Changes in version 3.1.3.RELEASE (2018-11-27)
---------------------------------------------
* DATAES-503 - Missing copy_to property in @Field Annotation.
* DATAES-496 - Release 3.1.3 (Lovelace SR3).
* DATAES-492 - Missing normalizer property in @Field and @InnerField Annotation.
* DATAES-445 - Usage example of scan and scroll is misleading.


Changes in version 3.0.12.RELEASE (2018-11-27)
----------------------------------------------
* DATAES-503 - Missing copy_to property in @Field Annotation.
* DATAES-492 - Missing normalizer property in @Field and @InnerField Annotation.
* DATAES-490 - Release 3.0.12 (Kay SR12).
* DATAES-445 - Usage example of scan and scroll is misleading.


Changes in version 2.1.17.RELEASE (2018-11-27)
----------------------------------------------
* DATAES-491 - Release 2.1.17 (Ingalls SR17).


Changes in version 3.1.2.RELEASE (2018-10-29)
---------------------------------------------
* DATAES-489 - Release 3.1.2 (Lovelace SR2).


Changes in version 2.1.16.RELEASE (2018-10-15)
----------------------------------------------
* DATAES-484 - Release 2.1.16 (Ingalls SR16).


Changes in version 3.0.11.RELEASE (2018-10-15)
----------------------------------------------
* DATAES-485 - Release 3.0.11 (Kay SR11).


Changes in version 3.1.1.RELEASE (2018-10-15)
---------------------------------------------
* DATAES-486 - Release 3.1.1 (Lovelace SR1).


Changes in version 3.1.0.RELEASE (2018-09-21)
---------------------------------------------
* DATAES-480 - Release 3.1 GA (Lovelace).
* DATAES-479 - NativeSearchQueryBuilder should have a withHighlighter() method.


Changes in version 3.0.10.RELEASE (2018-09-10)
----------------------------------------------
* DATAES-473 - Release 3.0.10 (Kay SR10).


Changes in version 2.1.15.RELEASE (2018-09-10)
----------------------------------------------
* DATAES-474 - Release 2.1.15 (Ingalls SR15).


Changes in version 3.1.0.RC2 (2018-08-20)
-----------------------------------------
* DATAES-472 - Release 3.1 RC2 (Lovelace).


Changes in version 2.1.14.RELEASE (2018-07-27)
----------------------------------------------
* DATAES-463 - Release 2.1.14 (Ingalls SR14).
* DATAES-283 - Remove dependency to Commons Lang.


Changes in version 3.0.9.RELEASE (2018-07-26)
---------------------------------------------
* DATAES-470 - TransportClientFactoryBean does not parse clusterNodes correctly.
* DATAES-469 - Is org.elasticsearch:elasticsearch a necessary dependency?.
* DATAES-467 - No mapping found for [_score] in order to sort on.
* DATAES-465 - Release 3.0.9 (Kay SR9).
* DATAES-317 - Add query logging to ElasticsearchTemplate.
* DATAES-283 - Remove dependency to Commons Lang.


Changes in version 3.1.0.RC1 (2018-07-26)
-----------------------------------------
* DATAES-471 - Adapt to changes in immutable entities support.
* DATAES-470 - TransportClientFactoryBean does not parse clusterNodes correctly.
* DATAES-469 - Is org.elasticsearch:elasticsearch a necessary dependency?.
* DATAES-467 - No mapping found for [_score] in order to sort on.
* DATAES-464 - Add support for @ReadOnlyProperty to prevent properties from being written.
* DATAES-462 - Add support for mapping document scores to entities.
* DATAES-452 - Release 3.1 RC1 (Lovelace).
* DATAES-317 - Add query logging to ElasticsearchTemplate.


Changes in version 3.0.8.RELEASE (2018-06-13)
---------------------------------------------
* DATAES-460 - Avoid pulling in Netty 3 as dependency.
* DATAES-448 - Release 3.0.8 (Kay SR8).
* DATAES-420 - Analyzer of main field ignored when using @MultiField annotation.
* DATAES-312 - NullHandling.NULLS_LAST not working in query.sort.


Changes in version 2.1.13.RELEASE (2018-06-13)
----------------------------------------------
* DATAES-447 - Release 2.1.13 (Ingalls SR13).


Changes in version 3.1.0.M3 (2018-05-17)
----------------------------------------
* DATAES-451 - Adapt to SpEL extension API changes in Spring Data Commons.
* DATAES-440 - Release 3.1 M3 (Lovelace).
* DATAES-422 - Add support for IndicesOptions in search queries.
* DATAES-420 - Analyzer of main field ignored when using @MultiField annotation.
* DATAES-412 - Highlighted fields is not getting passed to the elastic search query.
* DATAES-363 - AbstractElasticsearchRepository.existsById(..) always returns true.
* DATAES-312 - NullHandling.NULLS_LAST not working in query.sort.
* DATAES-198 - @Version has no effect, so therefore is not useful with spring data elasticsearch.


Changes in version 3.0.7.RELEASE (2018-05-08)
---------------------------------------------
* DATAES-438 - Expected a boolean [true/false] for property [index] but got [not_analyzed].
* DATAES-437 - Release 3.0.7 (Kay SR7).
* DATAES-412 - Highlighted fields is not getting passed to the elastic search query.
* DATAES-402 - Paging not working correctly.
* DATAES-363 - AbstractElasticsearchRepository.existsById(..) always returns true.
* DATAES-198 - @Version has no effect, so therefore is not useful with spring data elasticsearch.


Changes in version 2.1.12.RELEASE (2018-05-08)
----------------------------------------------
* DATAES-436 - Release 2.1.12 (Ingalls SR12).


Changes in version 3.1.0.M2 (2018-04-13)
----------------------------------------
* DATAES-439 - Adapt to API changes in Spring Data Commons.
* DATAES-434 - Remove explicit declaration of Jackson library versions.
* DATAES-432 - Export composable repositories via CDI.
* DATAES-427 - Release 3.1 M2 (Lovelace).


Changes in version 3.0.6.RELEASE (2018-04-04)
---------------------------------------------
* DATAES-434 - Remove explicit declaration of Jackson library versions.
* DATAES-430 - Release 3.0.6 (Kay SR6).


Changes in version 2.1.11.RELEASE (2018-04-04)
----------------------------------------------
* DATAES-434 - Remove explicit declaration of Jackson library versions.
* DATAES-424 - Fix line endings.
* DATAES-423 - Release 2.1.11 (Ingalls SR11).


Changes in version 3.0.5.RELEASE (2018-02-28)
---------------------------------------------
* DATAES-429 - Release 3.0.5 (Kay SR5).


Changes in version 3.0.4.RELEASE (2018-02-19)
---------------------------------------------
* DATAES-425 - Release 3.0.4 (Kay SR4).


Changes in version 3.1.0.M1 (2018-02-06)
----------------------------------------
* DATAES-424 - Fix line endings.
* DATAES-414 - Reduce scope of Lo4j dependencies to test.
* DATAES-410 - Adapt API changes in Property in test cases.
* DATAES-401 - Release 3.1 M1 (Lovelace).
* DATAES-361 - log4j2.xml in classpath root of the library prevents Spring Boot's logging auto-configuration to work.


Changes in version 3.0.3.RELEASE (2018-01-24)
---------------------------------------------
* DATAES-424 - Fix line endings.
* DATAES-417 - Release 3.0.3 (Kay SR3).


Changes in version 2.1.10.RELEASE (2018-01-24)
----------------------------------------------
* DATAES-416 - Release 2.1.10 (Ingalls SR10).


Changes in version 3.0.2.RELEASE (2017-11-27)
---------------------------------------------
* DATAES-414 - Reduce scope of Lo4j dependencies to test.
* DATAES-411 - Release 3.0.2 (Kay SR2).


Changes in version 2.1.9.RELEASE (2017-11-27)
---------------------------------------------
* DATAES-408 - Ensure Spring 5 compatibility in Ingalls.
* DATAES-404 - Release 2.1.9 (Ingalls SR9).


Changes in version 3.0.1.RELEASE (2017-10-27)
---------------------------------------------
* DATAES-410 - Adapt API changes in Property in test cases.
* DATAES-400 - Release 3.0.1 (Kay SR1).
* DATAES-361 - log4j2.xml in classpath root of the library prevents Spring Boot's logging auto-configuration to work.


Changes in version 2.1.8.RELEASE (2017-10-11)
---------------------------------------------
* DATAES-391 - Release 2.1.8 (Ingalls SR8).


Changes in version 3.0.0.RELEASE (2017-10-02)
---------------------------------------------
* DATAES-397 - Add explicit automatic module name for Java 9.
* DATAES-395 - Upgrade to OpenWebBeans 2.0.1.
* DATAES-392 - Release 3.0 GA (Kay).


Changes in version 3.0.0.RC3 (2017-09-11)
-----------------------------------------
* DATAES-376 - Release 3.0 RC3 (Kay).


Changes in version 2.1.7.RELEASE (2017-09-11)
---------------------------------------------
* DATAES-378 - Release 2.1.7 (Ingalls SR7).


Changes in version 2.1.6.RELEASE (2017-07-26)
---------------------------------------------
* DATAES-374 - Release 2.1.6 (Ingalls SR6).


Changes in version 3.0.0.RC2 (2017-07-25)
-----------------------------------------
* DATAES-375 - Release 3.0 RC2 (Kay).


Changes in version 3.0.0.RC1 (2017-07-25)
-----------------------------------------
* DATAES-373 - Update ES to 5.5.0.
* DATAES-369 - Adapt to API changes in mapping subsystem.
* DATAES-359 - Release 3.0 RC1 (Kay).
* DATAES-274 - Jackson throws exception when deserializing Page.


Changes in version 2.1.5.RELEASE (2017-07-24)
---------------------------------------------
* DATAES-358 - Release 2.1.5 (Ingalls SR5).


Changes in version 3.0.0.M4 (2017-06-14)
----------------------------------------
* DATAES-353 - Release 3.0 M4 (Kay).
* DATAES-334 - Readme has broken jira link.
* DATAES-285 - Upgrade to Elasticsearch 5.0.


Changes in version 2.1.4.RELEASE (2017-06-08)
---------------------------------------------
* DATAES-349 - Release 2.1.4 (Ingalls SR4).


Changes in version 2.0.11.RELEASE (2017-06-07)
----------------------------------------------
* DATAES-348 - Release 2.0.11 (Hopper SR11).


Changes in version 3.0.0.M3 (2017-05-09)
----------------------------------------
* DATAES-352 - Adapt to API changes in CrudRepository.
* DATAES-350 - Adapt to moved CustomConversions to Spring Data Commons.
* DATAES-344 - Release 3.0 M3 (Kay).


Changes in version 2.0.10.RELEASE (2017-04-19)
----------------------------------------------
* DATAES-347 - Release 2.0.10 (Hopper SR10).


Changes in version 2.1.3.RELEASE (2017-04-19)
---------------------------------------------
* DATAES-346 - Release 2.1.3 (Ingalls SR3).


Changes in version 2.0.9.RELEASE (2017-04-19)
---------------------------------------------
* DATAES-336 - Release 2.0.9 (Hopper SR9).


Changes in version 2.1.2.RELEASE (2017-04-19)
---------------------------------------------
* DATAES-335 - Release 2.1.2 (Ingalls SR2).


Changes in version 3.0.0.M2 (2017-04-04)
----------------------------------------
* DATAES-342 - Adapt to API changes in RepositoryConfigurationExtensionSupport.
* DATAES-329 - Remove references to single-argument assertion methods of Spring.
* DATAES-328 - Integrate Data Commons Java 8 upgrade branch.
* DATAES-325 - Remove references to GenericCollectionTypeResolver in favor of ResolvableType.
* DATAES-322 - Update project documentation with the CLA tool integration.
* DATAES-315 - Adapt API in RepositoryFactoryBeanSupport implementation.
* DATAES-313 - Register repository factory in spring.factories for multi-store support.
* DATAES-311 - Release 3.0 M2 (Kay).


Changes in version 2.0.8.RELEASE (2017-03-02)
---------------------------------------------
* DATAES-329 - Remove references to single-argument assertion methods of Spring.
* DATAES-326 - Release 2.0.8 (Hopper SR8).


Changes in version 2.1.1.RELEASE (2017-03-02)
---------------------------------------------
* DATAES-329 - Remove references to single-argument assertion methods of Spring.
* DATAES-327 - Release 2.1.1 (Ingalls SR1).
* DATAES-325 - Remove references to GenericCollectionTypeResolver in favor of ResolvableType.


Changes in version 2.0.7.RELEASE (2017-01-26)
---------------------------------------------
* DATAES-319 - Release 2.0.7 (Hopper SR7).


Changes in version 2.1.0.RELEASE (2017-01-26)
---------------------------------------------
* DATAES-322 - Update project documentation with the CLA tool integration.
* DATAES-320 - Release 2.1 GA (Ingalls).


Changes in version 2.0.6.RELEASE (2016-12-21)
---------------------------------------------
* DATAES-304 - Release 2.0.6 (Hopper SR6).


Changes in version 2.1.0.RC1 (2016-12-21)
-----------------------------------------
* DATAES-315 - Adapt API in RepositoryFactoryBeanSupport implementation.
* DATAES-313 - Register repository factory in spring.factories for multi-store support.
* DATAES-289 - Upgrade to Elasticsearch 2.4.
* DATAES-284 - Downgrade to Jackson 2.7.5 until Elasticsearch is compatible with 2.8.
* DATAES-281 - Can't save entity without id setter.
* DATAES-275 - Release 2.1 RC1 (Ingalls).


Changes in version 3.0.0.M1 (2016-11-23)
----------------------------------------
* DATAES-307 - Set up 3.0 development.
* DATAES-306 - Release 3.0 M1 (Kay).


Changes in version 2.0.5.RELEASE (2016-11-03)
---------------------------------------------
* DATAES-300 - Release 2.0.5 (Hopper SR5).


Changes in version 2.0.4.RELEASE (2016-09-29)
---------------------------------------------
* DATAES-297 - Release 2.0.4 (Hopper SR4).


Changes in version 1.3.6.RELEASE (2016-09-29)
---------------------------------------------
* DATAES-299 - Release 1.3.6 (Gosling SR6).


Changes in version 1.3.5.RELEASE (2016-09-20)
---------------------------------------------
* DATAES-296 - Release 1.3.5 (Gosling SR5).


Changes in version 2.0.3.RELEASE (2016-09-20)
---------------------------------------------
* DATAES-281 - Can't save entity without id setter.
* DATAES-268 - Release 2.0.3 (Hopper SR3).


Changes in version 2.1.0.M1 (2016-07-27)
----------------------------------------
* DATAES-262 - Upgrade Elasticsearch to 2.3.3.
* DATAES-250 - Release 2.1 M1 (Ingalls).


Changes in version 2.0.2.RELEASE (2016-06-15)
---------------------------------------------
* DATAES-251 - Release 2.0.2 (Hopper SR2).


Changes in version 2.0.1.RELEASE (2016-04-06)
---------------------------------------------
* DATAES-249 - Release 2.0.1 (Hopper SR1).


Changes in version 2.0.0.RELEASE (2016-04-06)
---------------------------------------------
* DATAES-245 - Release 2.0 GA (Hopper).


Changes in version 2.0.0.RC1 (2016-03-18)
-----------------------------------------
* DATAES-241 - remove commons-collections dependency and use CollectionUtils from Spring Utils.
* DATAES-240 - Release 2.0 RC1 (Hopper).
* DATAES-238 - ElasticsearchTemplate.prepareUpdate() does not preserve routing parameter which is required for updating child documents.
* DATAES-237 - path-configuration fails to load configs from inside jars.
* DATAES-236 - Clear the search contexts associated with specified scroll id.
* DATAES-234 - CDI support can fail due to Set.toString() used as Map key.
* DATAES-211 - Upgrade to Elasticsearch 2.0.
* DATAES-188 - Source filtering feature Implementation.
* DATAES-124 - ElasticSearchTemplate should expose client.


Changes in version 1.4.0.M1 (2016-02-12)
----------------------------------------
* DATAES-232 - Add code of conduct.
* DATAES-231 - Release 1.4 M1 (Hopper).
* DATAES-230 - Remove unnecessary type check in AbstractElasticsearchRepository.
* DATAES-224 - ElasticsearchTemplate discards newlines in mappings and settings files.
* DATAES-221 - Adapt to changes in Spring Data Commons.
* DATAES-216 - Add support to Indices Boost.
* DATAES-210 - Typo in error message.
* DATAES-209 - Handle dynamic mapping annotation at field level.
* DATAES-194 - Tests should clean up "data" directory.
* DATAES-171 - findByIdNotIn not work.
* DATAES-94 - Bump to support ES 1.2.0.


Changes in version 1.3.2.RELEASE (2015-12-18)
---------------------------------------------
* DATAES-223 - Release 1.3.2 (Gosling).


Changes in version 1.3.1.RELEASE (2015-11-15)
---------------------------------------------
* DATAES-212 - Release 1.3.1 (Gosling).


Changes in version 1.1.4.RELEASE (2015-10-14)
---------------------------------------------
* DATAES-202 - Release 1.1.4 (Evans).


Changes in version 1.3.0.RELEASE (2015-09-01)
---------------------------------------------
* DATAES-193 - Release 1.3 GA (Gosling).
* DATAES-137 - Should work out of the box with Spring Data REST.


Changes in version 1.3.0.RC1 (2015-08-04)
-----------------------------------------
* DATAES-186 - Release 1.3 RC1 (Gosling).
* DATAES-182 - Switch from BeanWrapper to PersistentPropertyAccessor.


Changes in version 1.2.2.RELEASE (2015-07-28)
---------------------------------------------
* DATAES-184 - Release 1.2.2 (Fowler).


Changes in version 1.0.6.RELEASE (2015-07-01)
---------------------------------------------
* DATAES-173 - Release 1.0.6 (Dijkstra).


Changes in version 1.1.3.RELEASE (2015-07-01)
---------------------------------------------
* DATAES-174 - Release 1.1.3 (Evans).


Changes in version 1.2.1.RELEASE (2015-06-30)
---------------------------------------------
* DATAES-175 - Release 1.2.1 (Fowler).
* DATAES-164 - CriteriaQuery equals method has to use AND operator instead of OR.
* DATAES-155 - findAll(Iterable<ID> ids) doesn't set persistent entity id.


Changes in version 1.3.0.M1 (2015-06-02)
----------------------------------------
* DATAES-168 - Release 1.3 M1 (Gosling).
* DATAES-164 - CriteriaQuery equals method has to use AND operator instead of OR.
* DATAES-162 - Adapt API changes in Spring Data Commons to simplify custom repository base class registration.
* DATAES-159 - Bulk update with ElasticsearchTemplate.
* DATAES-158 - UpdateRequest.script not working.
* DATAES-157 - support deleteBy operation.
* DATAES-155 - findAll(Iterable<ID> ids) doesn't set persistent entity id.


Changes in version 1.2.0.RELEASE (2015-03-23)
---------------------------------------------
* DATAES-154 - Release 1.2 GA.


Changes in version 1.2.0.RC1 (2015-03-05)
-----------------------------------------
* DATAES-152 - Release 1.2 RC1.
* DATAES-151 - findAll(Iterable<ID> ids) uses id representation in source instead of ES id.
* DATAES-140 - Document fields should not be indexed for search.
* DATAES-135 - Add necessary implementation for improved multi-store behavior.
* DATAES-132 - support include_in_parent for nested fieldtype.
* DATAES-130 - Allow Spring EL usage in type attribute of @Document.
* DATAES-129 - Custom Repository Method for simple geo request does not work.
* DATAES-115 - FindBy projections for list returns only 10 results.
* DATAES-100 - Allow configurable searchTimeout.
* DATAES-94 - Bump to support ES 1.2.0.
* DATAES-91 - Support for 'suggest' operations.


Changes in version 1.1.2.RELEASE (2015-01-28)
---------------------------------------------
* DATAES-146 - Release 1.1.2.


Changes in version 1.0.5.RELEASE (2015-01-27)
---------------------------------------------
* DATAES-145 - Release 1.0.5.


Changes in version 1.2.0.M1 (2014-12-01)
----------------------------------------
* DATAES-134 - Release 1.2 M1.
* DATAES-94 - Support for Elasticsearch 1.2.0.
* DATAES-76 - Add support for mapping generation of inherited fields.


Changes in version 1.1.1.RELEASE (2014-10-30)
---------------------------------------------
* DATAES-133 - Release 1.1.1.


Changes in version 1.1.0.RELEASE (2014-09-05)
---------------------------------------------
* DATAES-128 - Release 1.1 GA.
* DATAES-125 - the name of the isAnnotated method doesn't correspond to method body.
* DATAES-123 - Custom repository implementations are not picked up when using CDI.
* DATAES-120 - Polish reference documentation.
* DATAES-106 - Add support for countBy projections.


Changes in version 1.0.4.RELEASE (2014-08-27)
---------------------------------------------
* DATAES-122 - Release 1.0.4.


Changes in version 1.1.0.RC1 (2014-08-13)
-----------------------------------------
* DATAES-119 - Release 1.1 RC1.
* DATAES-117 - Displaying proper error message for entities that don't have an Id.
* DATAES-116 - Fix url typo in readme.md.
* DATAES-114 - Move to Asciidoctor for reference documentation.
* DATAES-113 - Add support for custom implementations in CDI repositories.
* DATAES-97 - UpdateQuery and UpdateBuilder should use UpdateRequest instead of the IndexRequest.
* DATAES-93 - Allow Spring EL usage in index name attribute of @Document.
* DATAES-89 - Support geolocation queries.


Changes in version 1.0.2.RELEASE (2014-07-28)
---------------------------------------------
* DATAES-107 - Release 1.0.2.


Changes in version 1.1.0.M1 (2014-07-10)
----------------------------------------
* DATAES-102 - Release 1.1 M1.
* DATAES-96 - Add support for aggregation in ElasticsearchTemplate.
* DATAES-94 - Bump to support ES 1.2.0.


Changes in version 1.0.1.RELEASE (2014-06-30)
---------------------------------------------
* DATAES-99 - Release 1.0.1.


Changes in version 1.0.0.RELEASE (2014-05-20)
---------------------------------------------
* DATAES-90 - Release 1.0 GA.


Changes in version 1.0.0.RC1 (2014-05-02)
-----------------------------------------
* DATAES-79 - Upgrade to elasticsearch 1.1.0.
* DATAES-78 - Release 1.0 M2.
* DATAES-74 - NPE in MappingElasticsearchEntityInformation.
* DATAES-73 - NullPointerException while persist a Map as part of persistent entity.
* DATAES-72 - Enhance Delete Index in ElasticsearchTemplate.
* DATAES-71 - Enhance Create Index in ElasticsearchTemplate.
* DATAES-69 - Sorting on String field not working.
* DATAES-67 - ElasticsearchTemplate#count does not respect specified index.
* DATAES-65 - Overhaul README.md.
* DATAES-64 - Add dynamic settings using @Setting annotation.
* DATAES-61 - Upgrade to elasticsearch 1.0.1.
* DATAES-60 - Java config support - default values in TransportClientFactoryBean.
* DATAES-56 - while specifying index and type at runtime indexing is failing.
* DATAES-55 - polish test cases and remove unwanted files.
* DATAES-54 - Upgrade to elasticsearch 1.0.
* DATAES-53 - @Field annotations (perhaps others?) ignored in included objects on mapping creation.
* DATAES-52 - Support Get & Multi Get.
* DATAES-51 - Allow for multiple sort builders when using NativeSearchQuery.
* DATAES-48 - Mapping for multiple level nested document is getting created wrong.
* DATAES-47 - Spring Application(Context) is not getting started up if elasticsearch nodes are not available.
* DATAES-46 - Remove unused imports & class.
* DATAES-35 - Investigate why build failed.
* DATAES-14 - Dynamic Search Type Support.
* DATAES-2 - Apply Spring Data formatting to sources.


Release Notes - Spring Data Elasticsearch - Version 1.0 M2 (2014-03-27)
-----------------------------------------------------------------------
* DATAES-74 - NPE in MappingElasticsearchEntityInformation
* DATAES-73 - NullPointerException while persist a Map as part of persistent entity
* DATAES-69 - Sorting on String field not working
* DATAES-67 - ElasticsearchTemplate#count does not respect specified index
* DATAES-56 - while specifying index and type at runtime indexing is failing
* DATAES-53 - @Field annotations (perhaps others?) ignored in included objects on mapping creation
* DATAES-48 - Mapping for multiple level nested document is getting created wrong
* DATAES-35 - Investigate why build failed
* DATAES-72 - Enhance Delete Index in ElasticsearchTemplate
* DATAES-71 - Enhance Create Index in ElasticsearchTemplate
* DATAES-61 - Upgrade to elasticsearch 1.0.1
* DATAES-60 - Java config support - default values in TransportClientFactoryBean
* DATAES-54 - Upgrade to elasticsearch 1.0
* DATAES-47 - Spring Application(Context) is not getting started up if elasticsearch nodes are not available
* DATAES-14 - Dynamic Search Type Support
* DATAES-79 - Upgrade to elasticsearch 1.1.0
* DATAES-64 - Add dynamic settings using @Setting annotation
* DATAES-52 - Support Get & Multi Get
* DATAES-51 - Allow for multiple sort builders when using NativeSearchQuery
* DATAES-78 - Release 1.0 M2
* DATAES-65 - Overhaul README.md
* DATAES-55 - polish test cases and remove unwanted files
* DATAES-46 - Remove unused imports & class
* DATAES-2 - Apply Spring Data formatting to sources

Release Notes - Spring Data Elasticsearch - Version 1.0 M1 (2014-02-07)
-----------------------------------------------------------------------
* DATAES-9 - multiple elasticsearch cluster nodes not getting parsed if using property file
* DATAES-7 - Migrate to the latest version of elasticsearch 0.90.0
* DATAES-11 - Missing core types in org.springframework.data.elasticsearch.annotations.FieldType
* DATAES-15 - Upgrade to latest version of elasticsearch( 0.90.2 )
* DATAES-19 - Delete specific type in an index, Type exists check
* DATAES-22 - Add support for TransportClient additional parameters such as client.transport.ignore_cluster_name, client.transport.ping_timeout, client.transport.nodes_sampler_interval
* DATAES-8 - Add support for Index level configuration
* DATAES-17 - Add support to retrieve highlighted text in search result
* DATAES-1 - Migrate sources to SpringSource GitHub repository
* DATAES-3 - Move to Spring Data build system
* DATAES-4 - Initial round of JavaDoc polish
* DATAES-5 - Add Apache license headers where necessary
* DATAES-6 - Add ability to let NodeClient clean up working directory
* DATAES-45 - Release 1.0 M1.
* #42 - org.springframework.data.elasticsearch.client.NodeClientFactoryBean' is not a valid value for 'anyURI'
* #40 - how to create index for json objects?
* #38 - Configure with native Client with embedded elasticsearch
* #37 - embedded elasticsearch client - how to recover data after process is restarted?
* #36 - FieldType.Date annotation
* #35 - @Transient property still inserted into elastic
* #33 - timestamp mapping
* #32 - BigDecimal @Field(type = FieldType.Double)
* #31 - DATAES-33: Mapping of parent-child relationships
* #29 - Added DefaultMapper support to map only partial fields from result instead of whole source field.
* #28 - Documentation (README.md) for Geo Location / Filter Feature
* #27 - Adding support for letting Elasticsearch generate Id for document
* #25 - Aliases
* #24 - DATAES-31 Adding ability to use ES Java API setSource directly
* #22 - spring-elasticsearch-1.0.xsd not found on www.springframework.com
* #21 - Autogenerated elastic search id isn't returned
* #20 - Exception while using CustomRepository
* #19 - Compilation issue with 0.90.5. (ElasticsearchTemplate.refresh API)
* #18 - problem with ES 0.9.5
* #17 - FacetResult extension is not possible
* #16 - Configuration of ObjectMapper in the ElasticsearchTemplate
* #15 - Added support for @Transient annotation to skip fields from mapping
* #14 - added format and pattern  support for date fieldtype + fixed nullpointer...
* #12 - Where is the maven repository for this artifact?
* #11 - Build fails
* #10 - Elasticsearch + elasticsearch-river-rabbitmq
* #9 - MappingBuilder circular reference issue
* #8 - java.lang.NoSuchMethodError: org.springframework.data.elasticsearch.core.mapping.ElasticsearchPersistentProperty.isVersionProperty()Z
* #7 - Missing core types in org.springframework.data.elasticsearch.annotations.FieldType
* #6 - spirng-data-elasticsearch with elasticsearch-river-mongodb
























































